;##################################################################
; ODListbox
;##################################################################

#include ODListbox.h

DATA SECTION
	hInstance	HANDLE		?
	hLBBrush	HANDLE		?
	hImgList	HANDLE		?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,esp,8,0x3FFF
	add esp,8
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx,esi,edi
	LOCAL pt				:POINT
	LOCAL rc				:RECT
	LOCAL TextBuffer[256]	:B

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke CreateSolidBrush,0FF00h
		mov [hLBBrush],eax
		invoke ImageList_LoadImage,[hInstance],"toolbar1.bmp",32,32,0C0C0C0h,IMAGE_BITMAP,LR_CREATEDIBSECTION + LR_LOADFROMFILE
		mov [hImgList],eax

		// Add a few sample items
		invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,"Test1"
		// Set the image list index by storing it in the ITEMDATA
		invoke SendDlgItemMessage,[hwnd],1001,LB_SETITEMDATA,eax,0

		invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,"Test2"
		invoke SendDlgItemMessage,[hwnd],1001,LB_SETITEMDATA,eax,1
		invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,"Test3"
		invoke SendDlgItemMessage,[hwnd],1001,LB_SETITEMDATA,eax,2
		invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,"Test4"
		invoke SendDlgItemMessage,[hwnd],1001,LB_SETITEMDATA,eax,3
		invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,"Test5"
		invoke SendDlgItemMessage,[hwnd],1001,LB_SETITEMDATA,eax,4
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_DRAWITEM

		jmp >>.EXIT

	.WM_DRAWITEM
	cmp D[uMsg],WM_DRAWITEM
	jne >>.WM_MEASUREITEM
		mov ebx,[lParam]
		cmp D[wParam],1001
		jne >>.DEFPROC
			mov B[TextBuffer],0

			// Save the address of the RECT
			mov esi,ebx
			add esi,DRAWITEMSTRUCT.rcItem
			// make a copy of the RECT structure
			lea edi,rc
			mov ecx,4
			rep movsd
			// reset the registers
			sub esi,16
			sub edi,16

			mov eax,[ebx+DRAWITEMSTRUCT.itemState]
			test eax,ODS_SELECTED
			jz >
			invoke SetTextColor,[ebx+DRAWITEMSTRUCT.hdc],000000FFh
			invoke FillRect,[ebx+DRAWITEMSTRUCT.hdc],esi,[hLBBrush]
			jmp >.DRAWIT
			:
			invoke SetTextColor,[ebx+DRAWITEMSTRUCT.hdc],00FF0000h
			invoke GetStockObject,WHITE_BRUSH
			invoke FillRect,[ebx+DRAWITEMSTRUCT.hdc],esi,eax
			.DRAWIT
			invoke SetBkMode,[ebx+DRAWITEMSTRUCT.hdc],TRANSPARENT
			
			invoke SendMessage,[ebx+DRAWITEMSTRUCT.hwndItem],LB_GETTEXT,\
				[ebx+DRAWITEMSTRUCT.itemID],OFFSET TextBuffer

			// adjust the left side by enough for the graphic
			add D[edi+RECT.left],32
			invoke DrawText,[ebx+DRAWITEMSTRUCT.hdc],OFFSET TextBuffer,-1,\
				edi,DT_LEFT+DT_SINGLELINE+DT_VCENTER

			// Set the RECT back to the original value
			sub D[edi+RECT.left],32
			// Get the image index
			invoke SendDlgItemMessage,[hwnd],[wParam],LB_GETITEMDATA,[ebx+DRAWITEMSTRUCT.itemID],0
			// Draw the image
			invoke ImageList_Draw,[hImgList],eax,[ebx+DRAWITEMSTRUCT.hdc],[edi+RECT.left],[edi+RECT.top],ILD_TRANSPARENT

			xor eax,eax
			inc eax
			ret

	.WM_MEASUREITEM
	cmp D[uMsg],WM_MEASUREITEM
	jne >>.WM_CLOSE
		// Measurements for the list box
		mov edi,[lParam]
		cmp D[wParam],1001
		jne >>.DEFPROC
			// Just set the height to the height of an image (32 in this case)
			mov D[edi+MEASUREITEMSTRUCT.itemHeight],32
			xor eax,eax
			inc eax
			ret

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		invoke DeleteObject,[hLBBrush]
		invoke ImageList_Destroy,[hImgList]
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF
